Skip to main content

Recursion - Hard Level - Question 1

Recursion - Hard Level - Question 1


Leetcode 761 Special Binary String

Special binary strings are binary strings with the following two properties:

The number of 0's is equal to the number of 1's.

Every prefix of the binary string has at least as many 1's as 0's.

You are given a special binary string s.

A move consists of choosing two consecutive, non-empty, special substrings of s, and swapping them. Two strings are consecutive if the last character of the first string is exactly one index before the first character of the second string.

Return the lexicographically largest resulting string possible after applying the mentioned operations on the string.

Constraints:

1 <= s.length <= 50

s[i] is either '0' or '1'.

s is a special binary string.


Analysis:

One way to solve this problem is to find all the 'special binary strings', and then just sort them reversely, and then concatenate them together.

The problem becomes how to break the input string down to sub-'special binary strings'. Based on the question, we can use a counter to count the number of '1' and '0'. Once them are the same, then it should be a 'special binary string'.

But there are cases that the 'special binary string' may NOT the optimal one (or NOT the one with the largest lexicographical value). For example, "11011000". This string itself is 'special binary string', but it is NOT the largest lexicographical one (which should be "11100100" for this example). 

Now the problem becomes how to make every 'special binary string' to be lexicographically largest, which essentially the same question as the original question! 

This is good, but we have to achieve the second condition before we can develop an algorithm of recursion: smaller size or shrinking the size of the question.

One of the key observation is that: the special binary string always start with '1' and end with '0'. Now the second condition can be realized: we just need to recursively adjust the the inner substring with the size smaller by 2.


See the code below:

class Solution {
public:
    string makeLargestSpecial(string s) {
        string res = "";
        int n = s.size();
        // base case
        if(!n) return res;
        vector<string> ss;
        int ct = 0, start = 0;
        for(int i=0; i<n; ++i) {
            if(s[i] == '1') ++ct;
            else --ct;
            if(!ct) {
                // recursive call
                string t = makeLargestSpecial(s.substr(start+1, i-start-1));
                ss.push_back("1" + t + "0");
                start = i + 1;
            }
        }
        sort(ss.begin(), ss.end(), greater<string>());
        for(auto &t : ss) res += t;
        return res;
    }
};

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...